%{!?_rel:%{expand:%%global _rel 0.r%(test "1015" != "0000" && echo "1015" || svnversion | sed 's/[^0-9].*$//' | grep '^[0-9][0-9]*$' || echo 0000)}}
%define debug_package %{nil}

Name: warewulf-provision
Summary: Warewulf - Provisioning Module
Version: 3.2
Release: %{_rel}
License: US Dept. of Energy (BSD-like)
Group: System Environment/Clustering
Source: %{name}-%{version}.tar.gz
ExclusiveOS: linux
Requires: warewulf-common
BuildRequires: warewulf-common
Conflicts: warewulf < 3
BuildRoot: %{?_tmppath}%{!?_tmppath:/var/tmp}/%{name}-%{version}-%{release}-root

%description
Warewulf >= 3 is a set of utilities designed to better enable
utilization and maintenance of clusters or groups of computers.  The
provision module provides functionality for provisioning, configuring,
and booting systems.

This package contains the core provisioning components and
administrative tools.  To actually provision systems, the
%{name}-server package is also required.


%package server
Summary: Warewulf - Provisioning Module - Server
Group: System Environment/Clustering
Requires: %{name} = %{version}-%{release}
Requires: mod_perl httpd tftp-server dhcp

%description server
Warewulf >= 3 is a set of utilities designed to better enable
utilization and maintenance of clusters or groups of computers.  The
provision module provides functionality for provisioning, configuring,
and booting systems.

This package contains the CGI scripts and event components to actually
provision systems.  Systems used solely for administration of Warewulf
do not require this package.


%package gpl_sources
Summary: This package contains the GPL sources used in Warewulf
Group: Development/System
Requires: %{name} = %{version}-%{release}

%description gpl_sources
Warewulf >= 3 is a set of utilities designed to better enable
utilization and maintenance of clusters or groups of computers.  The
provision module provides functionality for provisioning, configuring,
and booting systems.

Warewulf is distributed with some third-party software as a
convenience to our users.  While Warewulf itself is licensed under a
DOE license (a derivative of the BSD license), the third-party
software may have different licensing terms, including the GNU General
Public License (GPL).

In order to be 100% compatible with the GPL this package makes
available the included GPL software.


%prep
%setup -q


%build
%configure
%{__make} %{?mflags}


%install
%{__make} install DESTDIR=$RPM_BUILD_ROOT %{?mflags_install}


%post server
if [ $1 -eq 1 ] ; then
    # This is here for when people install warewulf-provision-server after
    # configuring nodes, vnfs, and bootstraps (which seems to be the number
    # one support issue so far!).
    %{_bindir}/wwsh dhcp update >/dev/null 2>&1 || :
    %{_bindir}/wwsh pxe update >/dev/null 2>&1 || :
    %{_bindir}/wwsh bootstrap build >/dev/null 2>&1 || :
elif [ $1 -eq 2 ] ; then
    # This is a horrid thing to do, but not doing it causes potential massive
    # incompatibilties between bootstrap and server thus making nodes not
    # bootable after an upgrade. This may go away or prove unnecessary
    # later.
    if [ -w /dev/tty ]; then
        echo "Rebuilding bootstrap objects; this may take a moment..." >/dev/tty
    else
        echo "Rebuilding bootstrap objects; this may take a moment..."
    fi
    %{_bindir}/wwsh bootstrap rebuild >/dev/null 2>&1 || :
fi
usermod -a -G warewulf apache >/dev/null 2>&1 || :
service httpd restart >/dev/null 2>&1 || :
chkconfig httpd on >/dev/null 2>&1 || :
chkconfig tftp on >/dev/null 2>&1 || :
chkconfig xinetd on >/dev/null 2>&1 || :
service xinetd restart >/dev/null 2>&1 || :


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README TODO LICENSE
%config(noreplace) %{_sysconfdir}/warewulf/provision.conf
%{_bindir}/*
%{_localstatedir}/warewulf/*
%{_datadir}/warewulf/*
%{perl_vendorlib}/Warewulf/Bootstrap.pm
%{perl_vendorlib}/Warewulf/Provision.pm
%{perl_vendorlib}/Warewulf/Vnfs.pm
%{perl_vendorlib}/Warewulf/DSO/*
%{perl_vendorlib}/Warewulf/Module/*
%{perl_vendorlib}/Warewulf/Provision
%{perl_vendorlib}/Warewulf/Event/DynamicHosts.pm


%files server
%defattr(-, root, root)
%config(noreplace) %{_sysconfdir}/httpd/conf.d/warewulf-httpd.conf
%{_libexecdir}/warewulf/cgi-bin/
%{perl_vendorlib}/Warewulf/Event/Bootstrap.pm
%{perl_vendorlib}/Warewulf/Event/Dhcp.pm
%{perl_vendorlib}/Warewulf/Event/Pxelinux.pm


%files gpl_sources
%defattr(-, root, root)
%{_prefix}/src/warewulf/3rd_party/GPL/


%changelog
